# To reduce boilerplate.
%global make_flags bindir=%{_bindir} CC=%{__cc}     \\\
CFLAGS="%{build_cflags}" LDFLAGS="%{build_ldflags}"

# Needed meta-data from git repo.
%global owner PTV_Claus
%global git_sha 69a35800d67cab71701e625cac56bfa62dc9c984
%global sha_short %(c=%{git_sha}; echo ${c:0:12})


Name:           cc1541
Version:        2.0
Release:        3%{?dist}
Summary:        Tool for creating Commodore 1541 Floppy disk images in D64, G64 or D71 format

License:        MIT
URL:            https://bitbucket.org/%{owner}/%{name}
Source0:        %{url}/get/%{version}.tar.bz2#/%{name}-%{version}.tar.bz2

BuildRequires:  gcc
BuildRequires:  git
BuildRequires:  make

# Patches from upstream.
Patch0001:      0001-Added-B-switch-to-specify-DIR-block-size.-Also-made-.patch
Patch0002:      0002-Tabs-to-spaces.patch
Patch0003:      0003-Initial-Bitbucket-Pipelines-configuration.patch
Patch0004:      0004-Add-make-target-to-run-tests.patch
Patch0005:      0005-Have-bitbucket-pipeline-run-tests-on-push.patch
Patch0006:      0006-Added-L-switch-to-reference-loop-files-by-index.patch
Patch0007:      0007-Trying-to-replace-gcc-Docker-image-with-minimal-make.patch
Patch0008:      0008-Trying-alpine-Docker-container-with-apk-command-to-i.patch
Patch0009:      0009-Resolve-strange-deviating-versions.patch
Patch0010:      0010-Fix-for-L-switch-used-always-index-0-and-also-did-no.patch
Patch0013:      0013-Adding-step-name-and-setting-binary-as-artifact-to-k.patch
Patch0014:      0014-Using-variable-for-compiler-to-prepare-for-MinGW-bui.patch
Patch0015:      0015-Add-manually-triggered-step-to-build-Windows-executa.patch
Patch0016:      0016-Changing-Docker-image-to-one-with-integrated-MinGW.patch
Patch0017:      0017-Adding-tests-to-Windows-build-step.patch
Patch0018:      0018-gitignore-Add-basic-ignore-rules-for-git.patch
Patch0019:      0019-LICENSE.txt-Add-license-file-for-distribution-packag.patch
Patch0020:      0020-Makefile-Allow-user-specified-compiler-flags-to-be-u.patch
Patch0021:      0021-Makefile-Run-top-level-clean-target-recursively.patch
Patch0022:      0022-Makefile-Add-top-level-check-test-target.patch
Patch0023:      0023-test_cc1541-Makefile-Add-check-target.patch
Patch0024:      0024-cc1541-Fix-Wmaybe-uninitialized.patch
Patch0025:      0025-cc1541-Fix-Wunused-result.patch
Patch0026:      0026-cc1541-Fix-Wformat-extra-args.patch
Patch0027:      0027-cc1541-Fix-Wformat.patch
Patch0028:      0028-cc1541-Fix-Wtype-limits.patch
Patch0029:      0029-test_cc1541-Fix-Wunused-result.patch
Patch0030:      0030-cc1541-Fix-segfault-with-GCC-8-and-O2.patch
Patch0031:      0031-test_cc1541-Flatten-the-directory-tree.patch
Patch0032:      0032-Makefile-Declare-some-targets-to-be-PHONY.patch
Patch0033:      0033-Makefile-Add-install-target.patch
Patch0034:      0034-Makefile-Handle-compiler-flags-properly.patch
Patch0035:      0035-Adapted-windows-build-files-to-new-flat-folder-struc.patch
Patch0036:      0036-Makefile-Remove-the-explicit-rules-for-linking.patch

%description
This is %{name} v%{version}, a tool for creating Commodore 1541
Floppy disk images in D64, G64 or D71 format with custom sector
interleaving etc.   Also supports extended tracks 35-40 using
either SPEED DOS or DOLPHIN DOS BAM-formatting.


%prep
%autosetup -S git -p 1 -n %{owner}-%{name}-%{sha_short}

# Remove pre-built binaries.
rm -fr rel/


%build
%make_build %{make_flags}


%install
%make_install %{make_flags}


%check
%make_build check %{make_flags}


%files
%license LICENSE.txt
%doc README.md
%{_bindir}/%{name}


%changelog
* Sun Jul 28 2019 Björn Esser <besser82@fedoraproject.org> - 2.0-3
- Add some upstream patches to improve rpm packaging

* Wed Jul 24 2019 Fedora Release Engineering <releng@fedoraproject.org> - 2.0-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_31_Mass_Rebuild

* Fri Jun 21 2019 Björn Esser <besser82@fedoraproject.org> - 2.0-1
- Initial import (#1722942)

* Fri Jun 21 2019 Björn Esser <besser82@fedoraproject.org> - 2.0-0.3
- Upstream PR has been merged

* Fri Jun 21 2019 Björn Esser <besser82@fedoraproject.org> - 2.0-0.2
- Remove pre-built binaries from build-tree during %%prep.

* Fri Jun 21 2019 Björn Esser <besser82@fedoraproject.org> - 2.0-0.1
- Initial rpm release (#1722942)
